/*
 * defs.h
 *
 * Created: 2016-03-16 13:37:20
 *  Author: dsosnowski
 */ 


#ifndef DEFS_H_
#define DEFS_H_


#define INPUT_PIN		2
#define OUTPUT_PIN		1
#define LED_PIN			0		//active 0
#define CF1_PIN			0
#define CF2_PIN			4
#define CF3_PIN			3
#define RST_PIN			5


#define LED_OFF			(DDRB &= ~(1<<LED_PIN))
#define LED_SET			(DDRB |=  (1<<LED_PIN))

#define OUT_OFF			(PORTB &= ~(1<<OUTPUT_PIN))
#define OUT_SET			(PORTB |=  (1<<OUTPUT_PIN))

#define MODE0_STANDARD			0
#define MODE1_STANDARD_RELOAD	1
#define MODE2_STANDARD_CLEAR	2
#define MODE3_ADD				3
#define MODE4_LOOP_CLEAR		4
#define MODE5_BISTABLE			5
#define MODE6_LEARN				6

#define TOFF_THR				4
#define TON_THR					4

#define INPUT_PRESS				3
#define INPUT_HOLD				2
#define INPUT_RELEASE			1
#define INPUT_IDLE				0

#define NEXT_IDLE				0
#define NEXT_NEXT				1
#define NEXT_RESTART			2
#define NEXT_FIRST				3
#define NEXT_END				4

#define MAIN_DELAY				10
#define LED_INTERVAL			200
#define TIMER_RESTART			TCNT0 = 0
#define TIMER_MAX				195
#define MAIN_MEMORY_RANGE		128
#define STEPS_RANGE				(MAIN_MEMORY_RANGE / 2)
#define STEPS_MAX				((MAIN_MEMORY_RANGE / 2) - 1)

#define TIME_MAX				0x7FFE
#define STATE_MASK				0x8000
#define TIME_MASK				0x7FFF

#endif /* DEFS_H_ */